From d7c1c88f0aa26374ac88cc3fcd1d851d168e2daf Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 16:17:26 +0100
Subject: [PATCH 09/54] fix: ensure fan control warning dialog has a reference
 to the root win to set it as transient for

---
 lact-gui/src/app/mod.rs                       |  2 +-
 lact-gui/src/app/root_stack/mod.rs            |  8 ++++++--
 .../src/app/root_stack/thermals_page/mod.rs   | 19 +++++++++----------
 3 files changed, 16 insertions(+), 13 deletions(-)

diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index 37c21a33..e5b9fa98 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -60,7 +60,7 @@ impl App {
             show_error(&window, err);
         }
 
-        let root_stack = RootStack::new(system_info, daemon_client.embedded);
+        let root_stack = RootStack::new(window.clone(), system_info, daemon_client.embedded);
 
         {
             let stack = root_stack.container.clone();
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 4734edc5..ccb71474 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -20,7 +20,11 @@ pub struct RootStack {
 }
 
 impl RootStack {
-    pub fn new(system_info: SystemInfo, embedded_daemon: bool) -> Self {
+    pub fn new(
+        root_win: libadwaita::ApplicationWindow,
+        system_info: SystemInfo,
+        embedded_daemon: bool,
+    ) -> Self {
         let container = Stack::builder().vexpand(true).hexpand(true).build();
 
         let info_page = InformationPage::new();
@@ -31,7 +35,7 @@ impl RootStack {
 
         container.add_titled(&oc_page.container, Some("oc_page"), "OC");
 
-        let thermals_page = ThermalsPage::new();
+        let thermals_page = ThermalsPage::new(root_win);
 
         container.add_titled(&thermals_page.container, Some("thermals_page"), "Thermals");
 
diff --git a/lact-gui/src/app/root_stack/thermals_page/mod.rs b/lact-gui/src/app/root_stack/thermals_page/mod.rs
index c7066332..8741626c 100644
--- a/lact-gui/src/app/root_stack/thermals_page/mod.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/mod.rs
@@ -1,17 +1,14 @@
 mod fan_curve_frame;
 
+use self::fan_curve_frame::FanCurveFrame;
+use super::{label_row, values_grid};
+use crate::app::page_section::PageSection;
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::{default_fan_curve, DeviceStats, FanControlMode, FanCurveMap};
 use libadwaita::prelude::MessageDialogExt;
 
-use crate::app::page_section::PageSection;
-
-use self::fan_curve_frame::FanCurveFrame;
-
-use super::{label_row, values_grid};
-
 #[derive(Debug)]
 pub struct ThermalsSettings {
     pub manual_fan_control: bool,
@@ -32,7 +29,7 @@ pub struct ThermalsPage {
 }
 
 impl ThermalsPage {
-    pub fn new() -> Self {
+    pub fn new(root_win: libadwaita::ApplicationWindow) -> Self {
         let container = Box::builder()
             .orientation(Orientation::Vertical)
             .spacing(15)
@@ -83,9 +80,9 @@ impl ThermalsPage {
 
         container.append(&fan_control_section);
 
-        fan_control_mode_stack.connect_visible_child_name_notify(|stack| {
+        fan_control_mode_stack.connect_visible_child_name_notify(move |stack| {
             if stack.visible_child_name() == Some("automatic".into()) {
-                show_fan_control_warning()
+                show_fan_control_warning(&root_win)
             }
         });
 
@@ -243,10 +240,12 @@ fn static_speed_adj(parent_box: &Box) -> Adjustment {
     adjustment
 }
 
-fn show_fan_control_warning() {
+fn show_fan_control_warning(root_win: &libadwaita::ApplicationWindow) {
     let diag = libadwaita::MessageDialog::builder()
         .heading("Warning")
         .body("Due to a driver bug, a reboot may be required for fan control to properly switch back to automatic")
+        .modal(true)
+        .transient_for(root_win)
         .build();
     diag.add_response("ok", "_Ok");
     diag.present();

